#!/usr/bin/perl -w
use POSIX;
use DBI;                                                                        
#use locale #(bei LC_TIME nicht ntig)

$ANZ_MASCH=24;
$count = 20;
$NoStop = 1;
#export LC_ALL=german
#setlocale(LC_TIME,"german");
&catch_signals;

#Erfassungskartentreiber ffnen 
open(DEV,"</dev/io8255") || die "Kartentreiber nicht geladen\n";
@zt=localtime;
$schicht=3;
if($zt[2]>=5) {$schicht=1;}
if($zt[2]>=13){$schicht=2};
if($zt[2]>=21){$schicht=3};         
 
$FileName = strftime ("/var/log/ehrlich/mde%Y%m%d",@zt) . "$schicht.log";
# Ausgabedatei ffnen 
open(LOG,">>$FileName") || die "Ausgabedatei $FileName kann nicht geffnet werden. \n";
# print LOG "\n";
$tag = strftime ("%Y-%m-%d",@zt);

print "Dateiname $FileName \n";
do {
  # jede Schicht eine neue Datei anfangen 
  $zt=time;
  @zt=localtime($zt);
  #for (@zt) { print "$_ - ";  }  print"\n";
  if (++$written>20 && $zt[1]==30 && ($zt[2]==5 || $zt[2]==13 || $zt[2]==21)) { 
  #if (++$written>2) {
    $written=0;
    close LOG;
    # Zykluszeit errechnen und in Datenbank schreiben                           

    $dbh = DBI->connect("DBI:mysql:ehrlich", "root", "");

    open(LOG,"</proc/io8255");
    $a=<LOG>;
    open(MASCH,"</home/daten/maschinen.txt");
    %masch = map {($a,$b,$c)=split;$a--;$a => [$b,$c];} <MASCH>;
    close(MASCH);
    $a=<LOG>;
    while (<LOG>) {
      ($IO, $q,$q,$q,$q, $Zyklen,$Zykluszeit,$ZyGesamt,$Unterbrechungen,$q,$UntGesamt)=split;
      last if exists($masch{$IO}) != 1;
      if ($ZyGesamt+$UntGesamt > 28820 ) { 
        print "$tag-$schicht $IO gestanden: $UntGesamt gelaufen: $ZyGesamt\n";	
	$UntGesamt = 28820 - $ZyGesamt;  # was nicht passt, wird passend gemacht...
      }
      $Zykluszeit = $Zykluszeit >= 999900 ? "NULL" : int($Zykluszeit/100)/10;
      if ($masch{$IO}[1]) {
        $sth = $dbh->prepare("INSERT INTO mdelog (tag,schicht,maschine,zykluszeit,schuss,unterbrechungen,sLauf,sStand) VALUES ('$tag',$schicht,$IO,$Zykluszeit,$Zyklen,$Unterbrechungen,$ZyGesamt,$UntGesamt)");
        $sth->execute;
      }
    }
    close LOG;
    $dbh->disconnect;
    #Fr Wochenende File Fr 3.Schicht merken
    if ($zt[6]==6 && $zt[2]==5) {$FileNameWe=$FileName};
    # jede Schicht ausdrucken, Wochenende aber nur ...
    print "starte Ausdruck: $zt[6] $zt[2]\n";
    if ($zt[6]==0  && $zt[2]==21 ) { #So 21.30
      system "schicht.pl -s 6 -t /etc/ehrlich/schicht.prn $FileNameWe | lpr -Plj6l &";
      #6 Schichten Beginn Fr 3.
    } elsif ( ($zt[6]==0 && $zt[2]<21) || $zt[6]==7) {  #Sa und So 1. u 2.
    } else {      
      system "schicht.pl -t /etc/ehrlich/schicht.prn $FileName | lpr -Plj6l &";
    }
    $schicht = ($schicht % 3) + 1;
    $FileName = strftime ("/var/log/ehrlich/mde%Y%m%d",@zt) . "$schicht.log";
    open(LOG,">$FileName") || die "Ausgabedatei $FileName kann nicht geffnet werden. \n";
    $tag = strftime ("%Y-%m-%d",@zt);
}
      
  if (!$written) {
    # Alle Zhler rcksetzen - RESET
    ioctl(DEV,0,int(0));                                                            
  }
  # Zykluszhler abholen und rcksetzen 
  read(DEV, $buf, $ANZ_MASCH+1) || print "Lesefehler\n" ;
  print LOG "$zt $buf\n";                      # Ausgabezeile schreiben 
  sleep(10);
} while ($NoStop || --$count);

sub catch_signals {
  $SIG{'INT'} = 'SIGNAL_CLEANUP';
  $SIG{'HUP'} = 'SIGNAL_CLEANUP';
  $SIG{'QUIT'} = 'SIGNAL_CLEANUP';
  $SIG{'PIPE'} = 'SIGNAL_CLEANUP';
  $SIG{'ALRM'} = 'SIGNAL_CLEANUP';
}

sub SIGNAL_CLEANUP {
  print "\nmdelog: interrupted!\n";
  close LOG;
  
  exit 2;
}

__END__
    
	  

