#!/usr/bin/perl
use POSIX;
use CGI qw/:standard :html3/;
#use Date::Format; 
setlocale(LC_TIME,"german");

$now=strftime("%A, %d. %B %H:%M", localtime(time()));
print header(-Refresh => "60; URL=$ENV{SCRIPT_NAME}"),
       start_html('-title' => "Schichtprotokoll"), 
       h2("Maschinenzustand vom $now");

#wenn heute, direkt aus /proc lesen, sonst SQL-Abfrage erstellen 
 
open(LOG,"</proc/io8255");
$a=<LOG>;
open(MASCH,"</home/daten/maschinen.txt");
%masch = map {($a,$b,$c)=split;$a--;$a => [$b,$c];} <MASCH>;
close(MASCH);

#print $a;
print "<TABLE border=1>\n";
print TR(th("Maschine"),th("steht seit"),th("Schu"),th("Zykluszeit"),
		th("Unterbrechungen"),th( "Zeit gelaufen"),
		th("Zeit gestanden"),th("Auslastung"));
$a=<LOG>;

while (<LOG>) {
  
	($IO, $L, $M, $Dauer, $q, $Zyklen, $Zykluszeit, $ZyGesamt,
	 $Unterbr, $UntZeit, $UntGesamt)=split;
	last if exists($masch{$IO}) != 1;
	$Auslastung = 0;
	if ($ZyGesamt + $UntGesamt) {
		$Auslastung = $ZyGesamt / ($ZyGesamt + $UntGesamt) 
	};
	$Zykluszeit = "-" if ($Zykluszeit >= 9999);
	#$Zykluszeit = $Zykluszeit >= 999900 ? "-" : int($Zykluszeit/100)/10;
	$Auslastung=int($Auslastung*100);
	print "<TR><TD>$masch{$IO}[0]</TD>";
	
	if ($masch{$IO}[1]) {      #Maschine hat Zyklen
		$BG = $M ? "lightgreen":"red";
		print "<TD  BGCOLOR=\"$BG\" >", hms($Dauer),
			'</TD><TD ALIGN="right" >';
		print join "</TD><TD ALIGN=\"right\" >", pZ($Zyklen),
			$Zykluszeit,pZ($Unterbr),
			hms($ZyGesamt),hms($UntGesamt),"$Auslastung%";
		print "</TD></TR>\n";
	} else {
		print "<TD COLSPAN=7>",$L ? 'aus':'an';
		print "</TD></TR>\n";
	}
}

close(LOG);
print "</TABLE >\n";
@types = ('Test');
print start_multipart_form(), br, submit('submit','Drucken'),
checkbox_group('count',\@types,\@types),
endform;

grep($stats{$_}++,param('count'));

if (%stats) {
	print strong("Drucker: "),$lines,br if $stats{'Test'};
#hier ausdrucken! 
} else {
	print strong("Kein Drucker gewhlt.");
}

&print_tail;

foreach $key ($query->param) {
	print "<STRONG>$key</STRONG> -> ";

	@values = $query->param($key);
	print join(", ",@values),"<BR>\n";
}


sub print_tail {
	#Links: gestern,letzte Woche,letzter Monat
	print <<END;
	<HR>
		<ADDRESS>Stefan Konrad Riedel</ADDRESS><BR>
		<A HREF="/">Home Page</A>
		END
		;
}


sub pZ {    # Punkte in groe Zahlen einfgen

	my $number = shift;
	while($number =~ s/(\d)(\d{3})\b/$1.$2/) { }
	return $number;
}

sub hms {    # Zahl in hh:mm:ss
	my $hms = shift;
	return sprintf '%02d:%02d:%02d',(gmtime($hms))[2,1,0];
}













